#ifndef ENBD_IOCTL_H
#define ENBD_IOCTL_H 1

int enbd_ioctl_convert(int ioctl);
int enbd_ioctl_convert_inplace(int *ioctl);
int enbd_ioctl_revert(int ioctl);
int enbd_ioctl_size (int cmd, char *arg);
int enbd_ioctl_size_user (int cmd, char *arg);
#ifdef __KERNEL__
int enbd_ioctl_copy_to_user (int cmd, char *arg, char *buf, int size);
int enbd_ioctl_copy_from_user (int cmd, char *buf, char *arg, int size);

/*
 * PTB object containing all the above methods, to be registered with
 * the enbd.o module
 */
struct enbd_ioctl {
#define ENBD_REMOTE_IOCTL_ENABLED 0x01
        unsigned long flags;
        int (*convert)        (int ioctl);
        int (*convert_inplace)(int *ioctl);
        int (*revert)         (int ioctl);
        int (*size)           (int cmd, char *arg);
        int (*size_user)      (int cmd, char *arg);
        int (*cp_to_user)     (int cmd, char *arg, char *buf, int size);
        int (*cp_from_user)   (int cmd, char *buf, char *arg, int size);
};

struct enbd_ioctl_stub {
        struct enbd_ioctl *    remote;
        int (*reg)       (struct enbd_ioctl_stub *,struct enbd_ioctl *);
        int (*unreg)     (struct enbd_ioctl_stub *,struct enbd_ioctl *);
};

extern struct enbd_ioctl_stub enbd_remote_ioctl;
extern int enbd_init_ioctl_stub(struct enbd_ioctl_stub *);
#endif

// PTB conversion table entries
struct ioctl_conv {
   unsigned int old; // ioctl id, _IO or _IOR or _IOW or _IOWR
   unsigned int new; // ioctl id
};

// PTB extended conversion table entries
struct ioctl_special {
    int new;
    int (*size) (char *arg);
    int (*size_user) (char *arg);
    int (*ioctl_copy_from_user)(char *buf, char*arg, int size);
    int (*ioctl_copy_to_user)(char *arg, char*buf, int size);
};

extern int enbd_init_ioctl_stub(struct enbd_ioctl_stub *);

#endif /* ENBD_IOCTL_H */
